dinit=date;

grid_z=20000;
simul_Z=rndn(grid_z,1);

/*We evaluate the criterion function at a collection of values X^{\tau). 
Below is the collection of values we use for \tau*/
cuantiles_vector=seqa(0.25,0.05,11);


/*Bandwidths are expressed as c*Stdev(X). Below is the collection of values that will be 
evaluated for the constant 'c'*/
r_c_vector=seqa(0.3,0.012,20);

MSE_pi_matrix=zeros(rows(cuantiles_vector),rows(r_c_vector));
MSE_pi_matrix_low=zeros(rows(cuantiles_vector),rows(r_c_vector));
MSE_pi_matrix_up=zeros(rows(cuantiles_vector),rows(r_c_vector));
MSE_pi_matrix_ipv=zeros(rows(cuantiles_vector),rows(r_c_vector));
MSE_prob_nosale_matrix=zeros(rows(cuantiles_vector),rows(r_c_vector));
MSE_combined_matrix=zeros(rows(cuantiles_vector),rows(r_c_vector));


library maxlik;
maxset;
__output=0;
_max_MaxIters=2000;


betas_matrix=zeros(13,10);
betas2_matrix=zeros(13,10);
n_bar=11;


/*To be used to compute phi (through a simple grid search)*/
grid_size=20000;
aux_grid=zeros(grid_size-1,1);
i=1;
do while i .le grid_size-1;
aux_grid[i]=i/grid_size;
i=i+1;
endo;



L=1113; /*Sample size*/
load datos_original[L,9]=data_file_auctions.asc;

B_original=datos_original[.,2];

datos_original=selif(datos_original, B_original .le 650);
L_original=rows(datos_original);


aux_vector_n=2|3|4|5|6|7|8|9|10|11;
aux_vector_Q_a=
0|(1/(3*(3-1)))|(1/(4*(4-1)))|(1/(5*(5-1)))|(1/(6*(6-1)))|(1/(7*(7-1)))|(1/(8*(8-1)))|(1/(9*(9-1)))|(1/(10*(10-1)))|(1/(11*(11-1)));



N_original=datos_original[.,1];
B_original=datos_original[.,2];
saleval_original=datos_original[.,3]/stdc(datos_original[.,3]);
mfgcost_original=datos_original[.,4]/stdc(datos_original[.,4]);
harvcost_original=datos_original[.,5]/stdc(datos_original[.,5]);
species_conc_original=datos_original[.,6]/stdc(datos_original[.,6]);
inventory_original=datos_original[.,7]/stdc(datos_original[.,7]);
apprice_original=datos_original[.,8]/stdc(datos_original[.,8]);
tvol_original=datos_original[.,9];
apprice=datos_original[.,8];

variables_original=saleval_original~mfgcost_original~harvcost_original~species_conc_original~inventory_original~apprice_original;

variables_original_plus_constant=ones(L_original,1)~variables_original;

projection_original=pinv(variables_original_plus_constant'*variables_original_plus_constant)*variables_original_plus_constant';

covariates_original=ones(L_original,1)~N_original~variables_original~N_original.*variables_original;

covariates_original_variance=covariates_original;


betas_E_N_m_X_matrix=projection_original*(N_original.*(N_original .lt
aux_vector_n'));
betas_E_N_X=projection_original*N_original;

proc loglikelih(bb,z);
local theta_mu, theta_sigma, index_mu, index_sigma;
local log_B, dens, sigma_2, zet;

log_B=ln(B_original);
theta_mu=bb[1:cols(covariates_original)];
theta_sigma=bb[cols(covariates_original)+1:cols(covariates_original)+cols(covariates_original_variance)];

index_mu=covariates_original*theta_mu;
index_sigma=sqrt(exp(covariates_original_variance*theta_sigma));

sigma_2=index_sigma.*index_sigma;

zet=(log_B-index_mu)./(sqrt(2)*(index_sigma));

dens=(1/B_original).*(1/sqrt(2*pi*sigma_2)).*exp(-zet.*zet);

retp(ln(dens));
endp;


bb0=zeros(cols(covariates_original),1)|ones(cols(covariates_original_variance),1)*1;
{beta_mle,f_mle,g_mle,cov_mle,ret_mle}=maxlik("aux_mle", 0, &loglikelih, bb0);

beta_mle_mu=beta_mle[1:cols(covariates_original)];

beta_mle_sigma=beta_mle[cols(covariates_original)+1:2*cols(covariates_original)];


proc loglikel(bb,z);
local indice_n, N_indicador, theta, covars_probabs;
local exp_covars, sum_exp_covars, indices_probabs, log_likel;
indice_n=seqa(2,1,9);
theta=reshape(bb,cols(variables_original)+1,rows(indice_n));
covars_probabs=(ones(L_original,1)~variables_original)*theta;
exp_covars=exp(covars_probabs);
sum_exp_covars=sumc(exp_covars');
indices_probabs=(exp_covars~ones(L_original,1))./(1+sum_exp_covars);
N_indicador=(N_original .eq aux_vector_n');
log_likel=sumc((N_indicador.*ln(indices_probabs))');
retp(log_likel);
endp;

bb0=zeros((cols(variables_original)+1)*9,1);
{xv,fff,ggg,cov,ret}=maxlik("aux_mle", 0, &loglikel, bb0);
probab_thetas_new=reshape(xv,cols(variables_original)+1,9);


sim=1;
do while sim .le rows(cuantiles_vector);
cuantil=cuantiles_vector[sim];


vv_0=ceil(quantile(apprice,cuantil));
reserve_price=selif(B_original, (B_original .ge vv_0).*(B_original .le 400));
gridsize=rows(reserve_price);

F_n_1_n_matrix_mle=zeros(gridsize,10);
phi_n_1_n_matrix_mle=zeros(gridsize,10);
T_r_x_param=zeros(gridsize,1);
prob_nosale_low_mle=zeros(gridsize,1);
prob_nosale_up_mle=zeros(gridsize,1);
prob_nosale_ipv_mle=zeros(gridsize,1);
pi_low_parametric=zeros(gridsize,1);
pi_up_parametric=zeros(gridsize,1);
pi_ipv_parametric=zeros(gridsize,1);


rr=1;
do while rr .le gridsize;
xx_value=quantile(saleval_original,cuantil)~quantile(mfgcost_original~harvcost_original,1-cuantil)
~quantile(species_conc_original,cuantil)~quantile(inventory_original,1-cuantil)~quantile(apprice_original,cuantil);

xx_value=xx_value';

xx_value_plus_constant=1|xx_value;

E_N_m_X_xx_value=sumc(xx_value_plus_constant.*betas_E_N_m_X_matrix);
E_N_X=sumc(xx_value_plus_constant.*betas_E_N_X);

prob_covars=(1~xx_value')*probab_thetas_new;
exp_prob_covars=exp(prob_covars);
sum_exp_prob_covars=sumc(exp_prob_covars');
indices_probab=(exp_prob_covars~1)./(1+sum_exp_prob_covars);
P_N_X=indices_probab';


mu_x_n_mle_vector=zeros(10,1);
sigma_x_n_mle_vector=zeros(10,1);

ene=2;
do while ene .le n_bar;
nn_value=ene;
covars_xx_value=1|nn_value|xx_value|nn_value.*xx_value;
mu_x_n_mle=sumc(covars_xx_value.*beta_mle_mu);
sigma_x_n_mle=sqrt(exp(sumc(covars_xx_value.*beta_mle_sigma)));
mu_x_n_mle_vector[ene-1]=mu_x_n_mle;
sigma_x_n_mle_vector[ene-1]=sigma_x_n_mle;
F_n_1_n_matrix_mle[rr,ene-1]=cdfn((ln(reserve_price[rr])-mu_x_n_mle)./sigma_x_n_mle);
aux_phi=sortc(aux_grid~(F_n_1_n_matrix_mle[rr,ene-1]-(nn_value*aux_grid^(nn_value-1)-(nn_value-1)*aux_grid^(nn_value)))^2,2);
phi_n_1_n_matrix_mle[rr,ene-1]=aux_phi[1,1];
ene=ene+1;
endo;

sigma_x_n_2_mle_vector=sigma_x_n_mle_vector^2;

mu_x_mle=sumc(mu_x_n_mle_vector.*P_N_X);

mu_x_2_mle=sumc((mu_x_n_mle_vector^2).*P_N_X);

var_mu_x_mle=mu_x_2_mle-mu_x_mle^2;

E_sigma_x_n_2_mle_vector=sumc(sigma_x_n_2_mle_vector.*P_N_X);

var_x_mle=var_mu_x_mle+E_sigma_x_n_2_mle_vector;

B_simul=exp(sqrt(var_x_mle)*simul_Z+mu_x_mle);

T_r_x_param[rr]=meanc(maxc((B_simul~ones(grid_z,1)*reserve_price[rr])'));

prob_nosale_low_mle[rr]=F_n_1_n_matrix_mle[rr,.]*(aux_vector_Q_a.*E_N_m_X_xx_value)+(E_N_X/n_bar)*(phi_n_1_n_matrix_mle[rr,10])^(n_bar);

prob_nosale_up_mle[rr]=F_n_1_n_matrix_mle[rr,.]*(aux_vector_Q_a.*E_N_m_X_xx_value)+(E_N_X/n_bar)*F_n_1_n_matrix_mle[rr,10];

prob_nosale_ipv_mle[rr]=(phi_n_1_n_matrix_mle[rr,.].^(aux_vector_n'))*P_N_X;

pi_low_parametric[rr]=T_r_x_param[rr]-vv_0-prob_nosale_up_mle[rr].*(reserve_price[rr]-vv_0);
pi_up_parametric[rr]=T_r_x_param[rr]-vv_0-prob_nosale_low_mle[rr].*(reserve_price[rr]-vv_0);
pi_ipv_parametric[rr]=T_r_x_param[rr]-vv_0-prob_nosale_ipv_mle[rr].*(reserve_price[rr]-vv_0);


rr=rr+1;
endo;

/*The previous portion of the program computed the MLE estimates for our reference model*/
/*HERE STARTS THE CONSTRUCTION OF OUR NONPARAMETRIC ESTIMATORS AND THE COMPARISON WITH THE 
REFERENCE MODEL*/

L=1113; /*Sample size*/
load datos[L,9]=data_file_auctions.asc;

B=datos[.,2];

datos=selif(datos, B .le 650);

L=rows(datos);


N=datos[.,1];
B=datos[.,2];
saleval=datos[.,3];
mfgcost=datos[.,4];
harvcost=datos[.,5];
species_conc=datos[.,6];
inventory=datos[.,7];
apprice=datos[.,8];
tvol=datos[.,9];


cont_covars=saleval~mfgcost~harvcost~species_conc~inventory~apprice;

xx_value=quantile(saleval,cuantil)~quantile(mfgcost~harvcost,1-cuantil)
~quantile(species_conc,cuantil)~quantile(inventory,1-cuantil)~quantile(apprice,cuantil);

z=cols(cont_covars); /*Number of continuous covariates in X*/


n_bar=11;

grid_bandwidth=rows(r_c_vector);

MSE_pi_low=zeros(grid_bandwidth,1);
MSE_pi_up=zeros(grid_bandwidth,1);
MSE_pi_ipv=zeros(grid_bandwidth,1);
MSE_prob_nosale_low=zeros(grid_bandwidth,1);
MSE_prob_nosale_up=zeros(grid_bandwidth,1);
MSE_prob_nosale_ipv=zeros(grid_bandwidth,1);

rrs=1;
do while rrs .le grid_bandwidth;

bandwidths=r_c_vector[rrs]*stdc(cont_covars)';

band_prod=1;
i=1;
do while i .le cols(bandwidths);
band_prod=band_prod*bandwidths[i];
i=i+1;
endo;



/*To be used to compute phi (through a simple grid search)*/
grid_size=20000;
aux_grid=zeros(grid_size-1,1);
i=1;
do while i .le grid_size-1;
aux_grid[i]=i/grid_size;
i=i+1;
endo;


grid_size_critical_value=20;
aux_grid_critical_value=zeros(grid_size_critical_value,1);
i=1;
do while i .le grid_size_critical_value;
aux_grid_critical_value[i]=minc(1.6448536+((1.9599640-1.6448536)/(grid_size_critical_value-1))*(i-1)|1.9599640);
i=i+1;
endo;

sup=20;
bb=3/10240000;

aux_vector_n_bis=3|4|5|6|7|8|9|10|11;

aux_vector_Q_a_bis=
(1/(3*(3-1)))|(1/(4*(4-1)))|(1/(5*(5-1)))|(1/(6*(6-1)))|(1/(7*(7-1)))|(1/(8*(8-1)))|(1/(9*(9-1)))|(1/(10*(10-1)))|(1/(11*(11-1)));

sup=20;
c1=-(693/1310720000);
c2=27027/671088640000000;
c3=-(2909907/4294967296000000000000);
c4=66927861/21990232555520000000000000000;


proc kernels(x);
local cont_values, x_val, r_val, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;
s_2=ones(L,z)*sup^2;
x_val=x[1:z];

cont_values=ones(L,z).*x_val;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(c1*(s_2-psi^2)^2+c2*(s_2-psi^2)^4+c3*(s_2-psi^2)^6+c4*(s_2-psi^2)^8).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;

kernel_vector=kernels(xx_value);
f_x_value=meanc(kernel_vector);



proc Q_a(x); /*Argument is "r" only*/
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim;

r_val=x[1];
vector_F_n_1=sumc((B .le r_val).*(N .eq
aux_vector_n_bis').*kernel_vector)./sumc((N .eq
aux_vector_n_bis').*kernel_vector);
E_N_m_N_x=sumc(N.*(N .lt aux_vector_n_bis').*kernel_vector)./sumc(kernel_vector);
Q_a_estim=sumc(aux_vector_Q_a_bis.*vector_F_n_1.*E_N_m_N_x);

retp(Q_a_estim);

endp;



proc T_a(x);
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim, max_B_r, T_a_estim;

r_val=x[1];
max_B_r=maxc((B~ones(L,1)*r_val)');
T_a_estim=sumc(max_B_r.*kernel_vector)./sumc(kernel_vector);

retp(T_a_estim);
endp;


proc F_phi_n_bar(x);
local r_val, ii, F_n_bar_estim, phi_n_bar_estim, aux_phi_nbar, aux_grid;
aux_grid=rndu(grid_size,1);
r_val=x[1];
F_n_bar_estim=sumc((B .le r_val).*(N .eq n_bar).*kernel_vector)./sumc((N
.eq n_bar).*kernel_vector);
aux_phi_nbar=sortc(aux_grid~(F_n_bar_estim-(n_bar*aux_grid^(n_bar-1)-(n_bar-1)*aux_grid^(n_bar)))^2,2);
phi_n_bar_estim=aux_phi_nbar[1,1];

retp(F_n_bar_estim~phi_n_bar_estim);
endp;



proc F_phi_x_IPV(x);
local n_vector_auxiliar, r_val, ii, F_n_bar_estim, phi_n_bar_estim,
aux_phi_nbar;
local Prob_n_x_vector, F_n_matriz, phi_matriz, aux_phi, F_x_IPV_estim, j;

n_vector_auxiliar=2|3|4|5|6|7|8|9|10|11;
r_val=x[1];

prob_n_x_vector=sumc((N .eq
n_vector_auxiliar').*kernel_vector)./sumc(kernel_vector);
F_n_matriz=sumc((B .le r_val).*(N .eq
n_vector_auxiliar').*kernel_vector)./sumc((N .eq
n_vector_auxiliar').*kernel_vector);

phi_matriz=zeros(10,1);

j=1;
do while j .le 10;
aux_phi=sortc(aux_grid~(F_n_matriz[j]-((j+1)*aux_grid^((j+1)-1)-((j+1)-1)*aux_grid^((j+1))))^2,2);
phi_matriz[j]=aux_phi[1,1];
j=j+1;
endo;

F_x_IPV_estim=sumc(phi_matriz.*prob_n_x_vector);

retp(F_n_matriz~phi_matriz);
endp;



E_N_x=sumc(kernel_vector.*N)./sumc(kernel_vector);
expected_profit_low=zeros(gridsize,1);
expected_profit_up=zeros(gridsize,1);
expected_profit_ipv=zeros(gridsize,1);
res_prices=zeros(gridsize,1);
prob_nosale_low=zeros(gridsize,1);
prob_nosale_up=zeros(gridsize,1);
prob_nosale_ipv=zeros(gridsize,1);

E_N_n_m_vector=meanc((N.*(N .lt aux_vector_n_bis')).*kernel_vector)/f_x_value;
q_x_m_vector=meanc((N .eq aux_vector_n_bis').*kernel_vector);

n_vector_auxiliar=2|3|4|5|6|7|8|9|10|11;

q_x_n_vector_ipv=meanc((N .eq n_vector_auxiliar').*kernel_vector);

P_n_x_vector=meanc((N .eq n_vector_auxiliar').*kernel_vector)/f_x_value;


mm=1;
do while mm .le gridsize;
res_prices[mm]=reserve_price[mm];
rr_value=reserve_price[mm];
aux_F_phi=F_phi_n_bar(rr_value);
F_n_bar_1_n_bar=aux_F_phi[1];
phi_n_bar_1_n_bar=aux_F_phi[2];
expected_profit_low[mm]=T_a(rr_value)-vv_0-(Q_a(rr_value)+(E_N_x/n_bar)*F_n_bar_1_n_bar)*(rr_value-vv_0);
prob_nosale_low[mm]=(Q_a(rr_value)+(E_N_x/n_bar)*F_n_bar_1_n_bar);
expected_profit_up[mm]=T_a(rr_value)-vv_0-(Q_a(rr_value)+(E_N_x/n_bar)*phi_n_bar_1_n_bar^(n_bar))*(rr_value-vv_0);
prob_nosale_up[mm]=(Q_a(rr_value)+(E_N_x/n_bar)*phi_n_bar_1_n_bar^(n_bar));
ipv_aux=F_phi_x_IPV(rr_value);
F_n_vector_ipv=ipv_aux[.,1];
phi_n_vector_ipv=ipv_aux[.,2]; /*Vector of \phi_{m}(F_{m-1:m}(r|x)), for
m=2,...,11*/
prob_nosale_ipv[mm]=((phi_n_vector_ipv.^n_vector_auxiliar)')*P_n_x_vector;
expected_profit_ipv[mm]=T_a(rr_value)-vv_0-prob_nosale_ipv[mm]*(rr_value-vv_0);
mm=mm+1;
endo;

MSE_pi_low[rrs]=meanc(((expected_profit_low-pi_low_parametric)./meanc(pi_low_parametric))^2 .*(res_prices .le 400));
MSE_pi_up[rrs]=meanc(((expected_profit_up-pi_up_parametric)./meanc(pi_up_parametric))^2 .*(res_prices .le 400));
MSE_pi_ipv[rrs]=meanc(((expected_profit_ipv-pi_ipv_parametric)./meanc(pi_ipv_parametric))^2 .*(res_prices .le 400));

MSE_prob_nosale_low[rrs]=meanc((prob_nosale_low_mle-prob_nosale_low)^2 );
MSE_prob_nosale_up[rrs]=meanc((prob_nosale_up_mle-prob_nosale_up)^2 );
MSE_prob_nosale_ipv[rrs]=meanc((prob_nosale_ipv_mle-prob_nosale_ipv)^2 );

MSE_pi_matrix_low[sim,rrs]=MSE_pi_low[rrs];
MSE_pi_matrix_up[sim,rrs]=MSE_pi_up[rrs];
MSE_pi_matrix_ipv[sim,rrs]=MSE_pi_ipv[rrs];
MSE_pi_matrix[sim,rrs]=MSE_pi_low[rrs]+MSE_pi_up[rrs]+MSE_pi_ipv[rrs];
MSE_prob_nosale_matrix[sim,rrs]=MSE_prob_nosale_low[rrs]+MSE_prob_nosale_up[rrs]+MSE_prob_nosale_ipv[rrs];
MSE_combined_matrix[sim,rrs]=MSE_pi_matrix[sim,rrs]+MSE_prob_nosale_matrix[sim,rrs];

rrs=rrs+1;
endo;


sim=sim+1;
endo;

sum_MSE_pi_low=sumc(MSE_pi_matrix_low);
sum_MSE_pi_up=sumc(MSE_pi_matrix_up);
sum_MSE_pi_ipv=sumc(MSE_pi_matrix_ipv);
sum_MSE_pi=sumc(MSE_pi_matrix);
sum_MSE_prob_nosale=sumc(MSE_prob_nosale_matrix);
sum_MSE_combined=sumc(MSE_combined_matrix);

aux_sorted_pi_low=sortc(sum_MSE_pi_low/maxc(sum_MSE_pi_low)~ceil(r_c_vector*100)/100,1);
aux_sorted_pi_up=sortc(sum_MSE_pi_up/maxc(sum_MSE_pi_up)~ceil(r_c_vector*100)/100,1);
aux_sorted_pi_ipv=sortc(sum_MSE_pi_ipv/maxc(sum_MSE_pi_ipv)~ceil(r_c_vector*100)/100,1);
aux_sorted_pi=sortc(sum_MSE_pi/maxc(sum_MSE_pi)~ceil(r_c_vector*100)/100,1);
aux_sorted_prob_nosale=sortc(sum_MSE_prob_nosale/maxc(sum_MSE_prob_nosale)~ceil(r_c_vector*100)/100,1);
aux_sorted_combined=sortc(sum_MSE_pi/maxc(sum_MSE_pi)+sum_MSE_prob_nosale/maxc(sum_MSE_prob_nosale)~ceil(r_c_vector*100)/100,1);

print "Bandwidth constant 'c' for counterfactuals:" aux_sorted_pi[1,2]; print " ";


dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;



