dinit=date;
rndseed(345869);

L=1113; /*Sample size*/
load datos[L,9]=data_file_auctions.asc;

B=datos[.,2];

datos=selif(datos, B .le 650);

L=rows(datos);


N=datos[.,1];
B=datos[.,2];
saleval=datos[.,3];
mfgcost=datos[.,4];
harvcost=datos[.,5];
species_conc=datos[.,6];
inventory=datos[.,7];
apprice=datos[.,8];
tvol=datos[.,9];


valores=zeros(ceil(maxc(B)),1);

i=1;
do while i .le ceil(maxc(B));
valores[i]=i-1;
i=i+1;
endo;


cont_covars=saleval~mfgcost~harvcost~species_conc~inventory~apprice;

z=cols(cont_covars); /*Number of continuous covariates in X*/

/*Conditioning values for X and seller's valuation (vv_0)*/
cuantil=0.90;
xx_value=quantile(saleval,cuantil)~quantile(mfgcost~harvcost,1-cuantil)~quantile(species_conc,cuantil)~quantile(inventory,1-cuantil)~quantile(apprice,cuantil);
vv_0=ceil(quantile(apprice,1-cuantil));


n_bar=11;

bandwidths=0.22*stdc(cont_covars)';
bandwidth_b=0.22*stdc(B);

band_prod=1;
i=1;
do while i .le cols(bandwidths);
band_prod=band_prod*bandwidths[i];
i=i+1;
endo;



/*To be used to compute phi (through a simple grid search)*/
grid_size=20000;
aux_grid=zeros(grid_size-1,1);
i=1;
do while i .le grid_size-1;
aux_grid[i]=i/grid_size;
i=i+1;
endo;


grid_size_critical_value=20;
aux_grid_critical_value=zeros(grid_size_critical_value,1);
i=1;
do while i .le grid_size_critical_value;
aux_grid_critical_value[i]=minc(1.6448536+((1.9599640-1.6448536)/(grid_size_critical_value-1))*(i-1)|1.9599640);
i=i+1;
endo;

sup=20;
bb=3/10240000;

aux_vector_n=3|4|5|6|7|8|9|10|11;
vector_all_n=2|aux_vector_n;

aux_vector_Q_a=
(1/(3*(3-1)))|(1/(4*(4-1)))|(1/(5*(5-1)))|(1/(6*(6-1)))|(1/(7*(7-1)))|(1/(8*(8-1)))|(1/(9*(9-1)))|(1/(10*(10-1)))|(1/(11*(11-1)));

proc kernels_b(x);
local cont_values, b_val, r_val, psi, kernel_vector;
local i, s_2;
s_2=sup^2;
b_val=x;

cont_values=ones(L,1).*b_val;
psi=(B-b_val)/bandwidth_b;

kernel_vector=(bb*(s_2-psi^2)^2).*(abs(psi) .le sup);

kernel_vector=kernel_vector/bandwidth_b;

retp(kernel_vector);
endp;

kernel_B_matrix=zeros(L,L);

i=1;
do while i .le L;
kernel_B_matrix[.,i]=kernels_b(B[i]);
i=i+1;
endo;


proc kernels(x);
local cont_values, x_val, r_val, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;
s_2=ones(L,z)*sup^2;
x_val=x[1:z];

cont_values=ones(L,z).*x_val;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(bb*(s_2-psi^2)^2).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;

kernel_vector=kernels(xx_value);
f_x_value=meanc(kernel_vector);
q_x_m_vector=meanc((N .eq vector_all_n').*kernel_vector);
P_N_x=meanc((N .eq vector_all_n').*kernel_vector)/f_x_value;

influence_P_N_x=zeros(L,10);
i=1;
do while i .le L;
influence_P_N_x[i,.]=((N[i] .eq vector_all_n')-P_N_x')/f_x_value;
i=i+1;
endo;


proc F_phi_vector(x); /*Argument is B[i] only*/
local B_ii, F_n_n_1_vec, aux_phi, phi_vec, j;
B_ii=x;
F_n_n_1_vec=sumc((B .le B_ii).*kernel_vector.*(N .eq vector_all_n'))./sumc(kernel_vector.*(N .eq vector_all_n'));
phi_vec=zeros(10,1);

j=1;
do while j .le 10;
aux_phi=sortc(aux_grid~(F_n_n_1_vec[j]-((j+1)*aux_grid^(j+1-1)-(j+1-1)*aux_grid^(j+1)))^2,2);
phi_vec[j]=aux_phi[1,1];
j=j+1;
endo;

retp(F_n_n_1_vec~phi_vec);
endp;




gridsize=ceil(quantile(apprice,0.90))+250;

gridsize=410;

u_n_upper_matrix=zeros(gridsize,10);
u_n_lower_matrix=zeros(gridsize,10);
u_n_ipv_matrix=zeros(gridsize,10);


u_n_lower_X_only=zeros(gridsize,1);
u_n_upper_X_only=zeros(gridsize,1);
u_n_ipv_X_only=zeros(gridsize,1);

critical_values_used=zeros(gridsize,1);
U_lower_conf_interval=zeros(gridsize,1);
U_upper_conf_interval=zeros(gridsize,1);
U_IPV_lower_conf_interval=zeros(gridsize,1);
U_IPV_upper_conf_interval=zeros(gridsize,1);
res_prices=zeros(gridsize,1);


matrix_F_n_n_1=zeros(L,10);
matrix_phi_n_n_1=zeros(L,10);


B_low=minc(B);
B_up=quantile(B, 0.995);
B_simul=ones(L,1)*B_low+rndu(L,1)*(B_up-B_low);

f_b=1/(B_up-B_low);

i=1;
do while i .le L;
aux_F_phi=F_phi_vector(B_simul[i]);
matrix_F_n_n_1[i,.]=aux_F_phi[.,1]';
matrix_phi_n_n_1[i,.]=aux_F_phi[.,2]';
i=i+1;
endo;


mm=1;
do while mm .le gridsize;
rr_value=0+mm-1;    
res_prices[mm]=rr_value;

infl_upper_u_n_matrix=zeros(L,10);
infl_lower_u_n_matrix=zeros(L,10);
infl_ipv_u_n_matrix=zeros(L,10);


n_value=2;
do while n_value .le n_bar;

F_upper_bound=zeros(L,1);
F_lower_bound=zeros(L,1);

q_x_n_value=q_x_m_vector[n_value-1];
F_IPV=zeros(L,1);
F_n_n_1=matrix_F_n_n_1[.,n_value-1];
phi_n_n_1=matrix_phi_n_n_1[.,n_value-1];


i=1;
do while i .le L;
sum_term=(n_value*(n_value .lt vector_all_n').*matrix_F_n_n_1[i,.])*(0|aux_vector_Q_a);
trail_term_F_upper_bound=(n_value/n_bar)*matrix_F_n_n_1[i,10];
trail_term_F_lower_bound=(n_value/n_bar)*(matrix_phi_n_n_1[i,10]^n_bar);
F_upper_bound[i]=sum_term+trail_term_F_upper_bound;
F_lower_bound[i]=sum_term+trail_term_F_lower_bound;
F_IPV[i]=phi_n_n_1[i]^(n_value);
i=i+1;
endo;


matrix_phi_tilde=zeros(L,10);
j=1;
do while j .le 10;
matrix_phi_tilde[.,j]=minc((matrix_phi_n_n_1[.,j]~ones(L,1)*0.999)');
matrix_phi_tilde[.,j]=maxc((matrix_phi_tilde[.,j]~ones(L,1)*0.001)');
j=j+1;
endo;


phi_prime_n_bar=(n_bar*(n_bar-1))^(-1)*(matrix_phi_n_n_1[.,10]^(2-n_bar)).*((1-matrix_phi_n_n_1[.,10])^(-1));

phi_prime_n_value=(n_value*(n_value-1))^(-1)*(phi_n_n_1^(2-n_value)).*((1-phi_n_n_1)^(-1));


phi_prime_n_bar=(matrix_phi_n_n_1[.,10])./((1-matrix_phi_n_n_1[.,10])*n_bar*(1-n_bar));

phi_prime_n_value=(phi_n_n_1)./((1-phi_n_n_1)*n_value*(1-n_value));


u_n_upper=zeros(gridsize,1);
u_n_lower=zeros(gridsize,1);
u_n_ipv=zeros(gridsize,1);

u_n_lower_bis=zeros(gridsize,1);
u_n_upper_bis=zeros(gridsize,1);
u_n_ipv_bis=zeros(gridsize,1);


u_n_upper[mm]=meanc(((F_n_n_1-F_lower_bound)./f_b).*(B_simul .ge rr_value));
u_n_lower[mm]=meanc(((F_n_n_1-F_upper_bound)./f_b).*(B_simul .ge rr_value));
u_n_ipv[mm]=meanc(((F_n_n_1-F_IPV)./f_b).*(B_simul .ge rr_value));


u_n_upper_matrix[mm,n_value-1]=u_n_upper[mm];
u_n_lower_matrix[mm,n_value-1]=u_n_lower[mm];
u_n_ipv_matrix[mm,n_value-1]=u_n_ipv[mm];


infl_U_upper_bound=zeros(L,1);
infl_U_lower_bound=zeros(L,1);
infl_U_IPV=zeros(L,1);


i=1;
do while i .le L;

aux_sum_infl=(n_value*(n_value .lt vector_all_n').*(ones(L,10).*(B[i] .le B_simul)-matrix_F_n_n_1).*(N[i] .eq vector_all_n')./q_x_m_vector')*(0|aux_vector_Q_a);

aux_trail_term_upper=(n_value/n_bar)*((B[i] .le B_simul)-matrix_F_n_n_1[.,10])/q_x_m_vector[10].*(N[i] .eq n_bar);

aux_trail_term_lower=n_value*phi_prime_n_bar.*((B[i] .le B_simul)-matrix_F_n_n_1[.,10])/q_x_m_vector[10].*(N[i] .eq n_bar);

aux_infl_F_upper=meanc(aux_sum_infl+aux_trail_term_upper);

aux_infl_F_lower=meanc(aux_sum_infl+aux_trail_term_lower);

auxiliar_infl_IPV=n_value*phi_prime_n_value.*((B[i] .le B_simul)-F_n_n_1).*(N[i] .eq vector_all_n[n_value-1])/q_x_n_value;

aux_infl_IPV=meanc(auxiliar_infl_IPV);

aux_first_term=meanc(((B[i] .le B_simul)-F_n_n_1).*(N[i] .eq vector_all_n[n_value-1])/q_x_n_value);

infl_U_lower_bound[i]=meanc(((aux_first_term-aux_infl_F_upper)./f_b).*(B_simul .ge rr_value));

infl_U_upper_bound[i]=meanc(((aux_first_term-aux_infl_F_lower)./f_b).*(B_simul .ge rr_value));

infl_U_IPV[i]=meanc(((aux_first_term-aux_infl_IPV)./f_b).*(B_simul .ge rr_value));

infl_upper_u_n_matrix[i,n_value-1]=infl_U_upper_bound[i];

infl_lower_u_n_matrix[i,n_value-1]=infl_U_lower_bound[i];

infl_ipv_u_n_matrix[i,n_value-1]=infl_U_IPV[i];


i=i+1;
endo;

n_value=n_value+1;
endo;

u_n_lower_X_only[mm]=u_n_lower_matrix[mm,.]*P_N_x;
u_n_upper_X_only[mm]=u_n_upper_matrix[mm,.]*P_N_x;
u_n_ipv_X_only[mm]=u_n_ipv_matrix[mm,.]*P_N_x;

full_influencia_lower=infl_lower_u_n_matrix*P_N_x+influence_P_N_x*u_n_lower_matrix[mm,.]';
full_influencia_upper=infl_upper_u_n_matrix*P_N_x+influence_P_N_x*u_n_upper_matrix[mm,.]';
full_influencia_ipv=infl_ipv_u_n_matrix*P_N_x+influence_P_N_x*u_n_ipv_matrix[mm,.]';


sigma_u_low=stdc(full_influencia_lower.*kernel_vector);
sigma_u_up=stdc(full_influencia_upper.*kernel_vector);
sigma_u_ipv=stdc(full_influencia_ipv.*kernel_vector);

delta=u_n_upper_X_only[mm]-u_n_lower_X_only[mm];

auxiliar_critical_values_U=sortc
(aux_grid_critical_value~
(cdfn(aux_grid_critical_value+sqrt(L)*delta/maxc(sigma_u_low|sigma_u_up))-cdfn(-aux_grid_critical_value)-0.95)^2,2);

critical_values_used[mm]=auxiliar_critical_values_U[1,1];
U_lower_conf_interval[mm]=u_n_lower_X_only[mm]-critical_values_used[mm]*sigma_u_low/sqrt(L);
U_upper_conf_interval[mm]=u_n_upper_X_only[mm]+critical_values_used[mm]*sigma_u_up/sqrt(L);

U_IPV_lower_conf_interval[mm]=u_n_ipv_X_only[mm]-1.9599640*sigma_u_ipv/sqrt(L);
U_IPV_upper_conf_interval[mm]=u_n_ipv_X_only[mm]+1.9599640*sigma_u_ipv/sqrt(L);



mm=mm+1;
endo;

u_low=u_n_lower_X_only;
u_up=u_n_upper_X_only;
u_ipv=u_n_ipv_X_only;

lower_confidence_ours=U_lower_conf_interval;
upper_confidence_ours=U_upper_conf_interval;
lower_confidence_ipv=U_IPV_lower_conf_interval;
upper_confidence_ipv=U_IPV_upper_conf_interval;


dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;






