dinit=date;

total_profits=0; /*1 if total profits, 0 if profits per unit*/


L=1113; /*Sample size*/
load datos[L,9]=data_file_auctions.asc;

B=datos[.,2];

datos=selif(datos, B .lt 650);

L=rows(datos);


N=datos[.,1];
B=datos[.,2];
saleval=datos[.,3];
mfgcost=datos[.,4];
harvcost=datos[.,5];
species_conc=datos[.,6];
inventory=datos[.,7];
apprice=datos[.,8];
tvol=datos[.,9];


if total_profits .eq 1;
volumen=tvol;
else;
volumen=ones(L,1);
endif;

vv_0=1*apprice;

cont_covars=saleval~mfgcost~harvcost~species_conc~inventory~apprice;

z=cols(cont_covars); /*Number of continuous covariates in X*/

OLS_B=(ones(L,1)~cont_covars)*inv((ones(L,1)~cont_covars)'*(ones(L,1)~cont_covars))*(ones(L,1)~cont_covars)'*B;


load reserve_price_LOW[L,1]=r_low.asc;
reserve_price_TEA=OLS_B;

reserve_price=reserve_price_LOW;

r_smaller_v0=(reserve_price .lt vv_0);

n_bar=11;

bandwidths=0.44*stdc(cont_covars)';

band_prod=1;
i=1;
do while i .le cols(bandwidths);
band_prod=band_prod*bandwidths[i];
i=i+1;
endo;



/*To be used to compute phi (through a simple grid search)*/
grid_size=20000;
aux_grid=zeros(grid_size-1,1);
i=1;
do while i .le grid_size-1;
aux_grid[i]=i/grid_size;
i=i+1;
endo;

aux_grid=0|rndu(grid_size-2,1)|1;

sup=20;
c1=-(693/1310720000);
c2=27027/671088640000000;
c3=-(2909907/4294967296000000000000);
c4=66927861/21990232555520000000000000000;

aux_vector_n=2|3|4|5|6|7|8|9|10|11;

aux_vector_Q_a=
(1/(3*(3-1)))|(1/(4*(4-1)))|(1/(5*(5-1)))|(1/(6*(6-1)))|(1/(7*(7-1)))|(1/(8*(8-1)))|(1/(9*(9-1)))|(1/(10*(10-1)))|(1/(11*(11-1)));


proc kernels(x);
local cont_values, x_val, r_val, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;
s_2=ones(L,z)*sup^2;
x_val=x[1:z];

cont_values=ones(L,z).*x_val;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(c1*(s_2-psi^2)^2+c2*(s_2-psi^2)^4+c3*(s_2-psi^2)^6+c4*(s_2-psi^2)^8).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;

kernel_matrix=zeros(L,L);
i=1;
do while i .le L;
kernel_matrix[.,i]=kernels(cont_covars[i,.]);
i=i+1;
endo;

kernel_matrix_influence=kernel_matrix; /*Same kernels for estimates and for standard error computations*/

q_X_m_matrix_prelim=zeros(L,10);

i=1;
do while i .le L;
q_X_m_matrix_prelim[i,.]=(meanc((N .eq aux_vector_n').*kernel_matrix[.,i]))';
i=i+1;
endo;

trim_q_xm_aux=(abs(q_X_m_matrix_prelim) .gt quantile(abs(q_X_m_matrix_prelim), 0.001));

trim_q_xm=minc(trim_q_xm_aux');

q_X_m_matrix=q_X_m_matrix_prelim.*trim_q_xm+(1-trim_q_xm).*ones(L,10)*minc(minc(selif(q_X_m_matrix_prelim[.,1], q_x_m_matrix_prelim[.,1] .gt 0)));

f_x_vector_prelim=meanc(kernel_matrix);

trim_f_x_value=quantile(selif(abs(f_x_vector_prelim),abs(f_x_vector_prelim) .gt 0), 0.001);

trim_f_x_value=quantile(abs(f_x_vector_prelim), 0.001);

trim_f_x=(f_x_vector_prelim .ge trim_f_x_value);

trim_f_x=(abs(f_x_vector_prelim) .ge trim_f_x_value);

f_x_vector=f_x_vector_prelim.*trim_f_x+(1-trim_f_x)*trim_f_x_value;

trim_x=trim_f_x.*trim_q_xm;



proc F_n_vector(x); /*Arguments are "r" and "i"*/
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim;
local kernel_vector;
local q_x_n;

r_val=x[1];
ii=x[2];

q_x_n=q_X_m_matrix[ii,.]';

kernel_vector=kernel_matrix[.,ii];

vector_F_n_1=(meanc((B .le r_val).*(N .eq aux_vector_n').*kernel_vector)./q_x_n);

vector_F_n_1=minc((vector_F_n_1~ones(10,1))');
vector_F_n_1=maxc((vector_F_n_1~zeros(10,1))');

retp(vector_F_n_1);

endp;

F_n_matrix_LOW=zeros(L,10);
F_n_matrix_UP=zeros(L,10);
F_n_matrix_IPV=zeros(L,10);
F_n_matrix_TEA=zeros(L,10);

load reserve_price_UP[L,1]=r_up.asc;
load reserve_price_IPV[L,1]=r_ipv.asc;

i=1;
do while i .le L;
F_n_matrix_LOW[i,.]=F_n_vector(reserve_price_LOW[i]|i)';
F_n_matrix_UP[i,.]=F_n_vector(reserve_price_UP[i]|i)';
F_n_matrix_IPV[i,.]=F_n_vector(reserve_price_IPV[i]|i)';
F_n_matrix_TEA[i,.]=F_n_vector(reserve_price_TEA[i]|i)';
i=i+1;
endo;


F_n_matrix=zeros(L,10);

i=1;
do while i .le L;
F_n_matrix[i,.]=F_n_vector(reserve_price[i]|i)';
i=i+1;
endo;

F_n_low=0.001;
F_n_up=0.999;

trim_x=trim_x.*minc((F_n_matrix_LOW .lt F_n_up)');
trim_x=trim_x.*minc((F_n_matrix_UP .lt F_n_up)');
trim_x=trim_x.*minc((F_n_matrix_IPV .lt F_n_up)');
trim_x=trim_x.*minc((F_n_matrix_TEA .lt F_n_up)');

prob_trim_x=meanc(trim_x);

F_n_zero_one=(F_n_matrix .lt F_n_up).*(F_n_matrix .gt F_n_low);

F_n_zero_one=(F_n_matrix .lt F_n_up);


proc phi_n_bar_(x); /*Argument is only "F_n_bar"*/
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim;
local F_n_bar, aux_phi_n, phi_n_estim,  ss;

F_n_bar=x[1];
aux_phi_n=sortc(aux_grid~(F_n_bar-((n_bar)*aux_grid^((n_bar)-1)-((n_bar)-1)*aux_grid^(n_bar)))^2,2);
phi_n_estim=aux_phi_n[1,1];

retp(phi_n_estim);

endp;


proc phi_n_vector(x); /*Argument is only "i"*/
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim;
local aux_phi_n, phi_n_estim,  ss;

ii=x[1];
vector_F_n_1=F_n_matrix[ii,.]';
phi_n_estim=zeros(10,1);
ss=1;
do while ss .le 10;
aux_phi_n=sortc(aux_grid~(vector_F_n_1[ss]-((ss+1)*aux_grid^((ss+1)-1)-((ss+1)-1)*aux_grid^(ss+1)))^2,2);
phi_n_estim[ss]=aux_phi_n[1,1];
ss=ss+1;
endo;

phi_n_estim=phi_n_estim;

retp(phi_n_estim);

endp;


phi_n_matrix=zeros(L,10);

i=1;
do while i .le L;
phi_n_matrix[i,.]=phi_n_vector(i)';
i=i+1;
endo;

phi_F_n_up=zeros(10,1);
rm=1;
do while rm .le 10;
aux_phi_F_n_up=sortc(aux_grid~(F_n_up-((rm+1)*aux_grid^((rm+1)-1)-((rm+1)-1)*aux_grid^(rm+1)))^2,2);
phi_F_n_up[rm]=aux_phi_F_n_up[1,1];
rm=rm+1;
endo;


tilde_phi_n_matrix=zeros(L,10);
j=1;
do while j .le 10;
tilde_phi_n_matrix[.,j]=minc((phi_n_matrix[.,j]~ones(L,1)*phi_F_n_up[j])');
j=j+1;
endo;


vector_auxiliar_phi_prime=zeros(10,1);
j=1;
do while j .le 10;
vector_auxiliar_phi_prime[j]=1/((j+1)*((j+1)-1));
j=j+1;
endo;


auxiliar_phi_prime_B=ones(L,10).*aux_vector_n';

phi_prime=ones(L,10).*(vector_auxiliar_phi_prime').*tilde_phi_n_matrix.*((1-tilde_phi_n_matrix)^(-1));


T_r_vector=zeros(L,1);

i=1;
do while i .le L;
if trim_x[i,.] .eq 1;
T_r_vector[i]= meanc(maxc((ones(L,1)*reserve_price[i]~B)').*kernel_matrix[.,i])/f_x_vector[i];
endif;
i=i+1;
endo;

T_r_vector=maxc((T_r_vector~reserve_price)');


T_r_vector_original=zeros(L,1);

i=1;
do while i .le L;
if trim_x[i,.] .eq 1;
T_r_vector_original[i]= meanc(maxc((ones(L,1)*vv_0[i]~B)').*kernel_matrix[.,i])/f_x_vector[i];
endif;
i=i+1;
endo;

T_r_vector_original=maxc((T_r_vector_original~vv_0)');


P_N_x_matrix=zeros(L,10);
i=1;
do while i .le L;
P_N_x_matrix[i,.]=(meanc((N .eq aux_vector_n').*kernel_matrix[.,i])/f_x_vector[i])';
i=i+1;
endo;

j=1;
do while j .le 10;
P_N_x_matrix[.,j]=minc((P_N_x_matrix[.,j]~ones(L,1))');
P_N_x_matrix[.,j]=maxc((P_N_x_matrix[.,j]~zeros(L,1))');
j=j+1;
endo;


P_N_le_m_matrix=zeros(L,9);

i=1;
do while i .le L;
P_N_le_m_matrix[i,.]=(meanc((N .lt aux_vector_n[2:10]').*kernel_matrix[.,i])/f_x_vector[i])';
i=i+1;
endo;

j=1;
do while j .le 9;
P_N_le_m_matrix[.,j]=minc((P_N_le_m_matrix[.,j]~ones(L,1))');
P_N_le_m_matrix[.,j]=maxc((P_N_le_m_matrix[.,j]~zeros(L,1))');
j=j+1;
endo;


E_N_N_m_matrix=zeros(L,9);

i=1;
do while i .le L;
E_N_N_m_matrix[i,.]=(meanc(N.*(N .lt aux_vector_n[2:10]').*kernel_matrix[.,i])/f_x_vector[i])';
i=i+1;
endo;

j=1;
do while j .le 9;
E_N_N_m_matrix[.,j]=maxc((E_N_N_m_matrix[.,j]~P_N_le_m_matrix[.,j]*2)');
j=j+1;
endo;

E_N_x_vector=meanc(N.*kernel_matrix)./f_x_vector;

E_N_x_vector=maxc((E_N_x_vector~ones(L,1)*2)');

pi_original=zeros(L,1);
pi_low=zeros(L,1);
pi_up=zeros(L,1);
pi_ipv=zeros(L,1);


prob_nosale_up=zeros(L,1);
prob_nosale_low=zeros(L,1);
prob_nosale_ipv=zeros(L,1);


i=1;
do while i .le L;

F_n_vector_reserve=F_n_vector(reserve_price[i]|i)';
phi_n_bar_reserve=phi_n_bar_(F_n_vector_reserve[10]);

T_r_aux= meanc(maxc((ones(L,1)*reserve_price[i]~B)').*kernel_matrix[.,i])/f_x_vector[i];
T_r_aux=maxc(T_r_aux|reserve_price[i]);

T_r_aux_original=meanc(maxc((ones(L,1)*vv_0[i]~B)').*kernel_matrix[.,i])/f_x_vector[i];
T_r_aux_original=maxc(T_r_aux_original|vv_0[i]);

sum_term_aux_profits=(0~E_N_N_m_matrix[i,.]).*(F_n_vector_reserve);
sum_term_profits=sum_term_aux_profits[.,2:10]*aux_vector_Q_a;
aux_profits_LOW=(E_N_x_vector[i]/n_bar)*F_n_vector_reserve[10];
aux_profits_UP=(E_N_x_vector[i]/n_bar)*phi_n_bar_reserve^n_bar;
prob_nosale_low[i]=(sum_term_profits+aux_profits_LOW);
prob_nosale_up[i]=(sum_term_profits+aux_profits_UP);
pi_original[i]=(T_r_aux_original-vv_0[i])*volumen[i];
pi_low[i]=(T_r_aux-vv_0[i]-prob_nosale_low[i]*(reserve_price[i]-vv_0[i]))*volumen[i];
pi_up[i]=(T_r_aux-vv_0[i]-prob_nosale_up[i]*(reserve_price[i]-vv_0[i]))*volumen[i];

phi_n_vector_reserve=phi_n_matrix[i,.]';
aux_phis_IPV=(phi_n_vector_reserve.^aux_vector_n).*(P_N_x_matrix[i,.]');
prob_nosale_ipv[i]=sumc(aux_phis_IPV);
pi_ipv[i]=(T_r_aux-vv_0[i]-prob_nosale_ipv[i]*(reserve_price[i]-vv_0[i]))*volumen[i];


i=i+1;
endo;

infl_function_ORIGINAL=zeros(L,1);
infl_function_profits_LOW=zeros(L,1);
infl_function_profits_UP=zeros(L,1);
infl_function_profits_IPV=zeros(L,1);
infl_function_nosale_LOW=zeros(L,1);
infl_function_nosale_UP=zeros(L,1);
infl_function_nosale_IPV=zeros(L,1);

infl_function_A=zeros(L,1);
infl_function_B_LOW=zeros(L,1);



i=1;

do while i .le L;

sum_term_aux_infl=(zeros(L,1)~E_N_N_m_matrix).*(ones(L,10).*(B[i] .le reserve_price)-F_n_matrix).*(N[i] .eq aux_vector_n').*F_n_zero_one./q_X_m_matrix;

sum_term_infl=sum_term_aux_infl[.,2:10]*aux_vector_Q_a;

sum_term_infl=sum_term_infl+(F_n_matrix[.,2:10].*((N.*(N .lt aux_vector_n[2:10]')-E_N_N_m_matrix)./f_x_vector))*aux_vector_Q_a;

first_auxiliar_infl=sum_term_infl.*trim_x;

second_auxiliar_index_LOW=((E_N_x_vector/n_bar).*(((B[i] .le reserve_price)-F_n_matrix[.,10])./q_X_m_matrix[.,10]).*(N[i] .eq n_bar).*F_n_zero_one[.,10]).*trim_x;

third_auxiliar_index_LOW=(F_n_matrix[.,10]/n_bar).*((N-E_N_x_vector)./f_x_vector).*F_n_zero_one[.,10].*trim_x;

aux_infl_function_a=((maxc((ones(L,1)*B[i]~reserve_price)')-T_r_vector)./f_x_vector).*trim_x;

aux_infl_function_a_original=((maxc((ones(L,1)*B[i]~vv_0)')-T_r_vector_original)./f_x_vector).*trim_x;

infl_function_B_LOW[i]=meanc((first_auxiliar_infl+second_auxiliar_index_LOW+third_auxiliar_index_LOW).*volumen.*kernel_matrix_influence[.,i]);

aux_infl_function_b_LOW=(first_auxiliar_infl+second_auxiliar_index_LOW+third_auxiliar_index_LOW).*(reserve_price-vv_0);

infl_function_A[i]=meanc(aux_infl_function_a.*volumen.*kernel_matrix_influence[.,i]);

infl_function_ORIGINAL[i]=meanc(aux_infl_function_a_original.*volumen.*kernel_matrix_influence[.,i]);

infl_function_profits_LOW[i]=meanc((aux_infl_function_a-aux_infl_function_b_LOW).*volumen.*kernel_matrix_influence[.,i]);

infl_function_nosale_LOW[i]=meanc((first_auxiliar_infl+second_auxiliar_index_LOW+third_auxiliar_index_LOW).*kernel_matrix_influence[.,i]);

second_auxiliar_index_UP=phi_prime[.,10].*E_N_x_vector/n_bar.*(((B[i] .le reserve_price)-F_n_matrix[.,10])./q_X_m_matrix[.,10]).*(N[i] .eq n_bar).*F_n_zero_one[.,10].*trim_x;

third_auxiliar_index_UP=(phi_n_matrix[.,10]^(n_bar)/n_bar).*((N-E_N_x_vector)./f_x_vector).*F_n_zero_one[.,10].*trim_x;

aux_infl_function_b_UP=(first_auxiliar_infl+second_auxiliar_index_UP+third_auxiliar_index_UP).*(reserve_price-vv_0);

infl_function_profits_UP[i]=meanc((aux_infl_function_a-aux_infl_function_b_UP).*volumen.*kernel_matrix_influence[.,i]);

infl_function_nosale_UP[i]=meanc((first_auxiliar_infl+second_auxiliar_index_UP+third_auxiliar_index_UP).*kernel_matrix_influence[.,i]);

aux_infl_IPV=phi_prime.*(ones(L,10).*(B[i] .le reserve_price)-F_n_matrix).*F_n_zero_one./q_X_m_matrix.*(ones(L,10).*(N[i] .eq aux_vector_n'));

aux_infl_IPV=aux_infl_IPV.*P_N_x_matrix;

aux_infl_IPV=aux_infl_IPV*aux_vector_n;

second_term_infl_nosale_IPV=phi_n_matrix.^(ones(L,10).*(aux_vector_n')).*((N .eq aux_vector_n')-P_N_x_matrix)./f_x_vector;

second_term_infl_nosale_IPV=sumc(second_term_infl_nosale_IPV');

second_term_infl_nosale_IPV=second_term_infl_nosale_IPV.*trim_x;

infl_function_nosale_IPV[i]=meanc((aux_infl_IPV+second_term_infl_nosale_IPV).*kernel_matrix_influence[.,i]);

aux_infl_function_b_IPV=meanc((aux_infl_IPV+second_term_infl_nosale_IPV).*(reserve_price-vv_0).*kernel_matrix_influence[.,i]);

infl_function_profits_IPV[i]=meanc((aux_infl_function_a-aux_infl_function_b_IPV).*volumen.*kernel_matrix_influence[.,i]);

i=i+1;
endo;


mean_profits_original=meanc(pi_original.*trim_x)/meanc(trim_x);

mean_profits_low=meanc(((pi_low).*(1-r_smaller_v0)+pi_up.*r_smaller_v0).*trim_x)/meanc(trim_x);

mean_profits_up=meanc(((pi_up).*(1-r_smaller_v0)+pi_low.*r_smaller_v0).*trim_x)/meanc(trim_x);

mean_profits_ipv=meanc(pi_ipv.*trim_x)/meanc(trim_x);

mean_change_profits_low=mean_profits_low-mean_profits_original;

mean_change_profits_up=mean_profits_up-mean_profits_original;

mean_change_profits_ipv=mean_profits_ipv-mean_profits_original;

mean_prob_nosale_low=meanc(prob_nosale_low.*trim_x)/meanc(trim_x);

mean_prob_nosale_up=meanc(prob_nosale_up.*trim_x)/meanc(trim_x);

mean_prob_nosale_ipv=meanc(prob_nosale_ipv.*trim_x)/meanc(trim_x);

full_infl_funct_profits_original=(pi_original.*trim_x+infl_function_original)/meanc(trim_x);

influencia_profits_low=(pi_low.*trim_x+infl_function_profits_low)/meanc(trim_x);

influencia_profits_up=(pi_up.*trim_x+infl_function_profits_up)/meanc(trim_x);

full_infl_funct_profits_low=influencia_profits_low.*(1-r_smaller_v0)+influencia_profits_up.*r_smaller_v0;

full_infl_funct_profits_up=influencia_profits_up.*(1-r_smaller_v0)+influencia_profits_low.*r_smaller_v0;

full_infl_funct_profits_ipv=(pi_ipv.*trim_x+infl_function_profits_ipv)/meanc(trim_x);

full_infl_funct_change_low=full_infl_funct_profits_low-full_infl_funct_profits_original;

full_infl_funct_change_up=full_infl_funct_profits_up-full_infl_funct_profits_original;

full_infl_funct_change_ipv=full_infl_funct_profits_ipv-full_infl_funct_profits_original;

full_infl_funct_nosale_low=(prob_nosale_low.*trim_x+infl_function_nosale_low)/meanc(trim_x);

full_infl_funct_nosale_up=(prob_nosale_up.*trim_x+infl_function_nosale_up)/meanc(trim_x);

full_infl_funct_nosale_ipv=(prob_nosale_ipv.*trim_x+infl_function_nosale_ipv)/meanc(trim_x);

full_infl_funct_nosale_ipv=selif(full_infl_funct_nosale_ipv, abs(full_infl_funct_nosale_ipv) .le quantile(abs(full_infl_funct_nosale_ipv),0.997));

conf_interval_profits_original=
mean_profits_original-1.96*stdc(full_infl_funct_profits_original)/sqrt(L)~mean_profits_original+1.96*stdc(full_infl_funct_profits_original)/sqrt(L);

conf_interval_profits_ipv=
mean_profits_ipv-1.96*stdc(full_infl_funct_profits_ipv)/sqrt(L)~mean_profits_ipv+1.96*stdc(full_infl_funct_profits_ipv)/sqrt(L);

conf_interval_profits_ours=
mean_profits_low-1.645*stdc(full_infl_funct_profits_low)/sqrt(L)~mean_profits_up+1.645*stdc(full_infl_funct_profits_up)/sqrt(L);

conf_interval_change_ipv=
mean_change_profits_ipv-1.96*stdc(full_infl_funct_change_ipv)/sqrt(L)~mean_change_profits_ipv+1.96*stdc(full_infl_funct_change_ipv)/sqrt(L);

conf_interval_change_ours=
mean_change_profits_low-1.645*stdc(full_infl_funct_change_low)/sqrt(L)~mean_change_profits_up+1.645*stdc(full_infl_funct_change_up)/sqrt(L);

full_infl_funct_nosale_ipv=selif(full_infl_funct_nosale_ipv, abs(full_infl_funct_nosale_ipv) .le quantile(abs(full_infl_funct_nosale_ipv),0.999));

conf_interval_nosale_ipv=
mean_prob_nosale_ipv-1.96*stdc(full_infl_funct_nosale_ipv)/sqrt(L)~mean_prob_nosale_ipv+1.96*stdc(full_infl_funct_nosale_ipv)/sqrt(L);

conf_interval_nosale_ours=
mean_prob_nosale_up-1.645*stdc(full_infl_funct_nosale_up)/sqrt(L)~mean_prob_nosale_low+1.645*stdc(full_infl_funct_nosale_low)/sqrt(L);

print "Average original profits:" mean_profits_original; print " ";

print "95% CI average original profits:" conf_interval_profits_original; print " ";

print "Estimated bounds in average profits:" mean_profits_low~mean_profits_up; print " ";

print "95% CI average profits:" conf_interval_profits_ours; print " ";

print "Average IPV-estimated profits:" mean_profits_ipv; print " ";

print "95% CI IPV average profits:" conf_interval_profits_ipv; print " ";

print "Estimated bounds change in profits:" mean_profits_low-mean_profits_original~mean_profits_up-mean_profits_original; print " ";

print "95% CI change in profits:" conf_interval_change_ours; print " ";

print "Estimated change in profits IPV:" mean_profits_ipv-mean_profits_original; print " ";

print "95% CI change in profits IPV:" conf_interval_change_ipv; print " ";

print "Estimated bounds no-sale probability:" mean_prob_nosale_up~mean_prob_nosale_low; print " ";

print "95% CI no-sale probability:" conf_interval_nosale_ours; print " ";

print "Estimated no-sale probability IPV:" mean_prob_nosale_ipv; print " ";

print "95% CI no-sale probability:" conf_interval_nosale_ipv; print " ";


dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;
