dinit=date;

cuantil=0.50; /*The conditioning value of X is X^(cuantil) as described in the paper*/

L=1113; /*Sample size*/
load datos[L,9]=data_file_auctions.asc;

B=datos[.,2];

datos=selif(datos, B .le 650);

L=rows(datos);


N=datos[.,1];
B=datos[.,2];
saleval=datos[.,3];
mfgcost=datos[.,4];
harvcost=datos[.,5];
species_conc=datos[.,6];
inventory=datos[.,7];
apprice=datos[.,8];
tvol=datos[.,9];


cont_covars=saleval~mfgcost~harvcost~species_conc~inventory~apprice;

z=cols(cont_covars); /*Number of continuous covariates in X*/


/*This describes the conditioning value of X and seller's valuation*/
xx_value=quantile(saleval,cuantil)~quantile(mfgcost~harvcost,1-cuantil)~quantile(species_conc,cuantil)~quantile(inventory,1-cuantil)~quantile(apprice,cuantil);

vv_0=ceil(quantile(apprice,cuantil));

n_bar=11;



/*To be used to compute phi (through a simple grid search)*/
grid_size=20000;
aux_grid=zeros(grid_size-1,1);
i=1;
do while i .le grid_size-1;
aux_grid[i]=i/grid_size;
i=i+1;
endo;


grid_size_critical_value=20;
aux_grid_critical_value=zeros(grid_size_critical_value,1);
i=1;
do while i .le grid_size_critical_value;
aux_grid_critical_value[i]=minc(1.6448536+((1.9599640-1.6448536)/(grid_size_critical_value-1))*(i-1)|1.9599640);
i=i+1;
endo;


sup=20;
bb=3/10240000;

aux_vector_n=3|4|5|6|7|8|9|10|11;

aux_vector_Q_a=
(1/(3*(3-1)))|(1/(4*(4-1)))|(1/(5*(5-1)))|(1/(6*(6-1)))|(1/(7*(7-1)))|(1/(8*(8-1)))|(1/(9*(9-1)))|(1/(10*(10-1)))|(1/(11*(11-1)));

bandwidths=0.22*stdc(cont_covars)';

band_prod=1;
i=1;
do while i .le cols(bandwidths);
band_prod=band_prod*bandwidths[i];
i=i+1;
endo;
 

proc kernels(x);
local cont_values, x_val, r_val, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;
s_2=ones(L,z)*sup^2;
x_val=x[1:z];

cont_values=ones(L,z).*x_val;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(bb*(s_2-psi^2)^2).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;

kernel_vector=kernels(xx_value);
f_x_value=meanc(kernel_vector);



proc Q_a(x); /*Argument is "r" only*/
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim;

r_val=x[1];
vector_F_n_1=sumc((B .le r_val).*(N .eq aux_vector_n').*kernel_vector)./sumc((N .eq aux_vector_n').*kernel_vector);
E_N_m_N_x=sumc(N.*(N .lt aux_vector_n').*kernel_vector)./sumc(kernel_vector);
Q_a_estim=sumc(aux_vector_Q_a.*vector_F_n_1.*E_N_m_N_x);

retp(Q_a_estim);

endp;



proc T_a(x);
local r_val, ii, vector_F_n_1, E_N_m_N_x, Q_a_estim, max_B_r, T_a_estim; 

r_val=x[1];
max_B_r=maxc((B~ones(L,1)*r_val)');
T_a_estim=sumc(max_B_r.*kernel_vector)./sumc(kernel_vector);

retp(T_a_estim);
endp;


proc F_phi_n_bar(x);
local r_val, ii, F_n_bar_estim, phi_n_bar_estim, aux_phi_nbar, aux_grid;
aux_grid=rndu(grid_size,1); 
r_val=x[1];
F_n_bar_estim=sumc((B .le r_val).*(N .eq n_bar).*kernel_vector)./sumc((N .eq n_bar).*kernel_vector);
aux_phi_nbar=sortc(aux_grid~(F_n_bar_estim-(n_bar*aux_grid^(n_bar-1)-(n_bar-1)*aux_grid^(n_bar)))^2,2);
phi_n_bar_estim=aux_phi_nbar[1,1];

retp(F_n_bar_estim~phi_n_bar_estim);
endp;



proc F_phi_x_IPV(x);
local n_vector_auxiliar, r_val, ii, F_n_bar_estim, phi_n_bar_estim, aux_phi_nbar;
local Prob_n_x_vector, F_n_matriz, phi_matriz, aux_phi, F_x_IPV_estim, j;

n_vector_auxiliar=2|3|4|5|6|7|8|9|10|11; 
r_val=x[1];

prob_n_x_vector=sumc((N .eq n_vector_auxiliar').*kernel_vector)./sumc(kernel_vector);    
F_n_matriz=sumc((B .le r_val).*(N .eq n_vector_auxiliar').*kernel_vector)./sumc((N .eq n_vector_auxiliar').*kernel_vector); 

phi_matriz=zeros(10,1);

j=1;
do while j .le 10;
aux_phi=sortc(aux_grid~(F_n_matriz[j]-((j+1)*aux_grid^((j+1)-1)-((j+1)-1)*aux_grid^((j+1))))^2,2);
phi_matriz[j]=aux_phi[1,1];
j=j+1;
endo;

F_x_IPV_estim=sumc(phi_matriz.*prob_n_x_vector);

retp(F_n_matriz~phi_matriz);
endp;


gridsize=300;

gridsize=ceil(410-vv_0);

E_N_x=sumc(kernel_vector.*N)./sumc(kernel_vector);
expected_profit_low=zeros(gridsize,1);
expected_profit_up=zeros(gridsize,1);
expected_profit_ipv=zeros(gridsize,1);
res_prices=zeros(gridsize,1);
critical_values_used=zeros(gridsize,1);
profit_lower_conf_interval=zeros(gridsize,1);
profit_upper_conf_interval=zeros(gridsize,1);
profit_IPV_lower_conf_int=zeros(gridsize,1);
profit_IPV_upper_conf_int=zeros(gridsize,1);


E_N_n_m_vector=meanc((N.*(N .lt aux_vector_n')).*kernel_vector)/f_x_value;
q_x_m_vector=meanc((N .eq aux_vector_n').*kernel_vector);

n_vector_auxiliar=2|3|4|5|6|7|8|9|10|11;

q_x_n_vector_ipv=meanc((N .eq n_vector_auxiliar').*kernel_vector);

P_n_x_vector=meanc((N .eq n_vector_auxiliar').*kernel_vector)/f_x_value;


mm=1;
do while mm .le gridsize;
rr_value=vv_0+mm;    
res_prices[mm]=rr_value;
aux_F_phi=F_phi_n_bar(rr_value);
F_n_bar_1_n_bar=aux_F_phi[1];
phi_n_bar_1_n_bar=aux_F_phi[2];
expected_profit_low[mm]=T_a(rr_value)-vv_0-(Q_a(rr_value)+(E_N_x/n_bar)*F_n_bar_1_n_bar)*(rr_value-vv_0);
expected_profit_up[mm]=T_a(rr_value)-vv_0-(Q_a(rr_value)+(E_N_x/n_bar)*phi_n_bar_1_n_bar^(n_bar))*(rr_value-vv_0);
ipv_aux=F_phi_x_IPV(rr_value);
F_n_vector_ipv=ipv_aux[.,1];
phi_n_vector_ipv=ipv_aux[.,2]; /*Vector of \phi_{m}(F_{m-1:m}(r|x)), for m=2,...,11*/
prob_nosale_ipv=((phi_n_vector_ipv.^n_vector_auxiliar)')*P_n_x_vector;
expected_profit_ipv[mm]=T_a(rr_value)-vv_0-prob_nosale_ipv*(rr_value-vv_0);


F_m_vector=meanc((B .le rr_value).*(N .eq aux_vector_n').*kernel_vector)./q_x_m_vector;
F_m_matrix=ones(L,9).*F_m_vector';
aux_infl_sum=((ones(L,9).*(B .le rr_value)-F_m_matrix)./q_x_m_vector').*(N .eq aux_vector_n').*(E_N_n_m_vector');
aux_infl_sum=aux_infl_sum*aux_vector_Q_a;

aux_infl_second=F_m_matrix.*(N.*(N .lt aux_vector_n')-ones(L,9).*E_N_n_m_vector');

aux_infl_second=(aux_infl_second*aux_vector_Q_a)/f_x_value;

aux_infl_sum=aux_infl_sum+aux_infl_second;

aux_infl_low=(E_N_x/n_bar)*(((B .le rr_value)-F_n_bar_1_n_bar)/q_x_m_vector[9]).*(N .eq n_bar);

phi_prime=phi_n_bar_1_n_bar/(n_bar*(1-n_bar)*(1-phi_n_bar_1_n_bar));
aux_infl_up=E_N_x*phi_prime*(((B .le rr_value)-F_n_bar_1_n_bar)/q_x_m_vector[9]).*(N .eq n_bar);


T_r_aux_infl=(maxc((B~ones(L,1)*rr_value)')-T_a(rr_value))/f_x_value;

aux_infl_up_last=((phi_n_bar_1_n_bar^(n_bar))/n_bar)*(N-E_N_x)/f_x_value;
aux_infl_low_last=(F_n_bar_1_n_bar/n_bar)*(N-E_N_x)/f_x_value;


influence_low=T_r_aux_infl-(rr_value-vv_0)*(aux_infl_sum+aux_infl_low+aux_infl_low_last);
influence_up=T_r_aux_infl-(rr_value-vv_0)*(aux_infl_sum+aux_infl_up+aux_infl_up_last);

influence_low=influence_low.*kernel_vector;
influence_up=influence_up.*kernel_vector;

aux_phi_prime_ipv=1/(2*(2-1))|aux_vector_Q_a;

phi_prime_vector_ipv=(aux_phi_prime_ipv).*(phi_n_vector_ipv)./(1-phi_n_vector_ipv); 
first_aux_infl_ipv=((N .eq n_vector_auxiliar').*(ones(L,10).*(B .le rr_value)-ones(L,10).*F_n_vector_ipv')./q_x_n_vector_ipv')*(P_n_x_vector.*phi_prime_vector_ipv);

second_aux_infl_ipv=((ones(L,10).*(N .eq n_vector_auxiliar')-ones(L,10).*P_n_x_vector')/f_x_value)*(phi_n_vector_ipv.^(n_vector_auxiliar));

infl_function_ipv=T_r_aux_infl-(rr_value-vv_0)*(first_aux_infl_ipv+second_aux_infl_ipv);

infl_function_ipv=infl_function_ipv.*kernel_vector;

sigma_IPV_estim=stdc(infl_function_ipv);

influence_up=selif(influence_up, abs(influence_up) .le quantile(abs(influence_up),0.999));
influence_low=selif(influence_low, abs(influence_low) .le quantile(abs(influence_low),0.999));

sigma_low_estim=stdc(influence_low);
sigma_up_estim=stdc(influence_up);

delta=expected_profit_up[mm]-expected_profit_low[mm];

auxiliar_critical_values_profits=sortc
(aux_grid_critical_value~
(cdfn(aux_grid_critical_value+sqrt(L)*delta/maxc(sigma_low_estim|sigma_up_estim))-cdfn(-aux_grid_critical_value)-0.95)^2,2);

critical_values_used[mm]=auxiliar_critical_values_profits[1,1];
profit_lower_conf_interval[mm]=expected_profit_low[mm]-critical_values_used[mm]*sigma_low_estim/sqrt(L);
profit_upper_conf_interval[mm]=expected_profit_up[mm]+critical_values_used[mm]*sigma_up_estim/sqrt(L);

profit_IPV_lower_conf_int[mm]=expected_profit_ipv[mm]-1.9599640*sigma_IPV_estim/sqrt(L);
profit_IPV_upper_conf_int[mm]=expected_profit_ipv[mm]+1.9599640*sigma_IPV_estim/sqrt(L);

mm=mm+1;
endo;

pi_low=expected_profit_low;
pi_up=expected_profit_up;
pi_ipv=expected_profit_ipv;

lower_confidence_ipv=profit_IPV_lower_conf_int;
upper_confidence_ipv=profit_IPV_upper_conf_int;

lower_confidence_ours=profit_lower_conf_interval;
upper_confidence_ours=profit_upper_conf_interval;


dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;

